const converter = (htmlString) => {
    var jiraString = htmlString;
    jiraString = jiraString.replaceAll("<h1>", "h1.");
    jiraString = jiraString.replaceAll("<h2>", "h2");
    jiraString = jiraString.replaceAll("<h3>", "h3.");
    jiraString = jiraString.replaceAll("<h4>", "h4.");
    jiraString = jiraString.replaceAll("<h5>", "h5.");
    jiraString = jiraString.replaceAll("<h6>", "h6.");
    jiraString = jiraString.replaceAll("</h1>", "");
    jiraString = jiraString.replaceAll("</h2>", "");
    jiraString = jiraString.replaceAll("</h3>", "");
    jiraString = jiraString.replaceAll("</h4>", "");
    jiraString = jiraString.replaceAll("</h5>", "");
    jiraString = jiraString.replaceAll("</h6>", "");
    jiraString = jiraString.replaceAll("<p>", "\\ \\");
    jiraString = jiraString.replaceAll("</p>", "");
    jiraString = jiraString.replaceAll("<i>", "_");
    jiraString = jiraString.replaceAll("</i>", "_");
    jiraString = jiraString.replaceAll("<em>", "_");
    jiraString = jiraString.replaceAll("</em>", "_");
    jiraString = jiraString.replaceAll("<b>", "*");
    jiraString = jiraString.replaceAll("</b>", "*");
    jiraString = jiraString.replaceAll("<strong", "*");
    jiraString = jiraString.replaceAll("</strong>", "*");
    jiraString = jiraString.replaceAll("<u>", "+");
    jiraString = jiraString.replaceAll("</u>", "+");
    jiraString = jiraString.replaceAll("<ins>", "+");
    jiraString = jiraString.replaceAll("</ins>", "+");
    jiraString = jiraString.replaceAll("<sup>", "^");
    jiraString = jiraString.replaceAll("</sup>", "^");
    jiraString = jiraString.replaceAll("<sub>", "~");
    jiraString = jiraString.replaceAll("</sub>", "~");
    jiraString = jiraString.replaceAll("<tt>", "{{");
    jiraString = jiraString.replaceAll("</tt>", "}}");
    jiraString = jiraString.replaceAll("<blockquote>", "{quote}");
    jiraString = jiraString.replaceAll("</blockquote>", "{quote}");
    jiraString = jiraString.replaceAll("</br>", "\\ \\");
    jiraString = jiraString.replaceAll("<br>", "\\ \\");
    jiraString = jiraString.replaceAll("<br/>", "\\ \\");
    jiraString = jiraString.replaceAll("<br />", "\\ \\");
    jiraString = jiraString.replaceAll("\n", "\\");
    jiraString = jiraString.replaceAll("<pre>", "{code}");
    jiraString = jiraString.replaceAll("</pre>", "{code}");
    jiraString = jiraString.replaceAll("<hr>", "----");

    var pattern = "<ol>(.|\n)*?</ol>";
    var result = jiraString.match(pattern);
    var resultChanged = "";
    if (result && result.length >= 0) {
        result = result[0];
        resultChanged = result.replaceAll("<ol>", "");
        resultChanged = result.replaceAll("</ol>", "");
        resultChanged = result.replaceAll("<li>", "*");
        resultChanged = result.replaceAll("</li>", "");
        jiraString = jiraString.replaceAll(result, resultChanged);
    }


    pattern = "<ul>(.|\n)*?</ul>";
    result = jiraString.match(pattern);
    if (result && result.length >= 0) {
        result = result[0];
        resultChanged = result.replaceAll("<ul>", "");
        resultChanged = result.replaceAll("</ul>", "");
        resultChanged = result.replaceAll("<li>", "#");
        resultChanged = result.replaceAll("</li>", "");
        jiraString = jiraString.replaceAll(result, resultChanged);
    }

    pattern = "<tr>(.|\n)*?<th(.|\n)*?</tr>";
    result = jiraString.match(pattern);
    if (result && result.length >= 0) {
        result = result[0];
        resultChanged = result.replaceAll("<tr>", "");
        resultChanged = result.replaceAll("<th>", "||");
        resultChanged = result.replaceAll("</th>", "");
        resultChanged = result.replaceAll("</tr>", "||\\");
        jiraString = jiraString.replaceAll(result, resultChanged);
    }

    pattern = "<tr>(.|\n)*?<td(.|\n)*?</tr>";
    result = jiraString.match(pattern);
    if (result && result.length >= 0) {
        result = result[0];
        resultChanged = result.replaceAll("<tr>", "");
        resultChanged = result.replaceAll("<td>", "|");
        resultChanged = result.replaceAll("</td>", "");
        resultChanged = result.replaceAll("</tr>", "|\\");
        jiraString = jiraString.replaceAll(result, resultChanged);
    }

    return jiraString;
};

const ignoreEmptyHtmlTags(tag, jiraString, replaceWith)
{
    var pattern = String.Format("<{0}>(.|\n)*?</{1}>", tag, tag);
    var result = jiraString.match(pattern);
    var resultChanged = "";
    while (result != "") {
        var tagsContent = result.match("(?<=<strong>)(.*?)(?=</strong>)");
        if (!/\S/.test(tagsContent)) { // if tagsContent empty or have only white spaces
            resultChanged = result.replaceAll(('<{0}> ', tag), "");
            resultChanged = resultChanged.replaceAll(('<{0}>', tag), "");
            resultChanged = resultChanged.replaceAll((' </{0}>', tag), "");
            resultChanged = resultChanged.replaceAll(('</{0}>', tag), "");
            jiraString = jiraString.replaceAll(result, resultChanged);
        }
        else {
            resultChanged = result.replaceAll(('<{0}> ', tag), replaceWith);
            resultChanged = resultChanged.replaceAll(('<{0}>', tag), replaceWith);
            resultChanged = resultChanged.replaceAll((' </{0}>', tag), replaceWith);
            resultChanged = resultChanged.replaceAll(('</{0}>', tag), replaceWith);
            jiraString = jiraString.replaceAll(result, resultChanged);
        }

        result = jiraString.match(pattern);
    }

    return jiraString;
}

module.exports = { converter };